"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const iterable_1 = require("../utils/iterable");
function skipWhile(source, predicate) {
    return iterable_1.iterable(function* () {
        let index = 0;
        let skipped = false;
        for (const element of source) {
            if (!skipped && predicate(element, index++)) {
                continue;
            }
            skipped = true;
            yield element;
        }
    });
}
exports.skipWhile = skipWhile;

//# sourceMappingURL=skipWhile.js.map
