"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function toGroups(source, keySelector, valueSelector) {
    let index = 0;
    const map = new Map();
    for (const element of source) {
        const key = keySelector(element, index);
        const value = valueSelector(element, index++);
        const values = map.get(key);
        if (values !== undefined) {
            values.push(value);
        }
        else {
            map.set(key, [value]);
        }
    }
    return map;
}
exports.toGroups = toGroups;

//# sourceMappingURL=toGroups.js.map
