export interface IterableCast<T> extends Iterable<T> {
    toArray(): T[];
    toArray<S>(selector: (element: T, index: number) => S): S[];
    toMap<M>(keySelector: (element: T, index: number) => M): Map<M, T>;
    toMap<M, N>(keySelector: (element: T, index: number) => M, valueSelector: (element: T, index: number) => N): Map<M, N>;
    toGroups<M>(keySelector: (element: T, index: number) => M): Map<M, T[]>;
    toGroups<M, N>(keySelector: (element: T, index: number) => M, valueSelector: (element: T, index: number) => N): Map<M, N[]>;
    toSet(): Set<T>;
    toSet<S>(selector: (element: T, index: number) => S): Set<S>;
    toString(): string;
}
