import { IterableQuery } from './IterableQuery';
export interface IterableFilter<T> extends Iterable<T> {
    filter(predicate: (element: T, index: number) => boolean): IterableQuery<T>;
    take(count: number): IterableQuery<T>;
    takeWhile(predicate: (element: T, index: number) => boolean): IterableQuery<T>;
    skip(count: number): IterableQuery<T>;
    skipWhile(predicate: (element: T, index: number) => boolean): IterableQuery<T>;
    slice(start?: number, end?: number): IterableQuery<T>;
    splice(start: number, deleteCount: number, ...items: T[]): IterableQuery<T>;
}
