import { IterableQuery } from './IterableQuery';
export interface IterableJoin<T> extends Iterable<T> {
    join<TKey, TRight, TResult>(other: Iterable<TRight>, leftKeySelector: (element: T, index: number) => TKey, rightKeySelector: (element: TRight, index: number) => TKey, joinSelector: (left: T, right: TRight) => TResult): IterableQuery<TResult>;
    leftJoin<TKey, TRight, TResult>(other: Iterable<TRight>, leftKeySelector: (element: T, index: number) => TKey, rightKeySelector: (element: TRight, index: number) => TKey, joinSelector: (left: T, right?: TRight) => TResult): IterableQuery<TResult>;
    rightJoin<TKey, TRight, TResult>(other: Iterable<TRight>, rightKeySelector: (element: TRight, index: number) => TKey, leftKeySelector: (element: T, index: number) => TKey, joinSelector: (right: TRight, left?: T) => TResult): IterableQuery<TResult>;
    groupJoin<TKey, TRight, TResult>(other: Iterable<TRight>, leftKeySelector: (element: T, index: number) => TKey, rightKeySelector: (element: TRight, index: number) => TKey, joinSelector: (left: T, right: TRight[]) => TResult): IterableQuery<TResult>;
}
