import { IterableCast } from './IterableCast';
import { IterableJoin } from './IterableJoin';
import { IterablePermutation } from './IterablePermutation';
import { IterablePredicate } from './IterablePredicate';
import { IterableFilter } from './IterableFilter';
import { IterableSet } from './IterableSet';
import { IterableTransformation } from './IterableTransformation';
import { IterableValue } from './IterableValue';
export interface IterableQuery<T> extends IterableValue<T>, IterablePredicate<T>, IterablePermutation<T>, IterableFilter<T>, IterableTransformation<T>, IterableSet<T>, IterableJoin<T>, IterableCast<T>, Iterable<T> {
    entries(): IterableQuery<[number, T]>;
    keys(): IterableQuery<number>;
    values(): IterableQuery<T>;
    concat(other: T | Iterable<T>): IterableQuery<T>;
    prepend(other: Iterable<T> | T): IterableQuery<T>;
    fill(value: T): IterableQuery<T>;
    fill(value: T, start: number): IterableQuery<T>;
    fill(value: T, start: number, end: number): IterableQuery<T>;
}
