import { IterableQuery } from './IterableQuery';
export interface IterableSet<T> extends Iterable<T> {
    distinct(): IterableQuery<T>;
    distinct<S>(selector: (element: T) => S): IterableQuery<T>;
    exclude(other: Iterable<T>): IterableQuery<T>;
    exclude<S>(other: Iterable<T>, selector: (element: T) => S): IterableQuery<T>;
    intersect(other: Iterable<T>): IterableQuery<T>;
    intersect<S>(other: Iterable<T>, selector: (element: T) => S): IterableQuery<T>;
    union(other: Iterable<T>): IterableQuery<T>;
    union<S>(other: Iterable<T>, selector: (element: T) => S): IterableQuery<T>;
}
