import { IterableQuery } from './IterableQuery';
export interface IterableTransformation<T> extends Iterable<T> {
    map<S>(selector: (element: T, index: number) => S): IterableQuery<S>;
    flat<S>(selector: (element: T, index: number) => Iterable<S>): IterableQuery<S>;
    groupBy<K>(keySelector: (element: T, index: number) => K): IterableQuery<[K, IterableQuery<T>]>;
    groupBy<K, E>(keySelector: (element: T, index: number) => K, valueSelector: (element: T, index: number) => E): IterableQuery<[K, IterableQuery<E>]>;
}
export interface IterableQueryGroup<K, T> extends IterableQuery<T> {
    readonly key: K;
}
