export interface IterableValue<T> extends Iterable<T> {
    nth(index: number): T | undefined;
    indexOf(element: T): number;
    indexOf(element: T, fromIndex: number): number;
    findIndex(predicate: (element: T, index: number) => boolean): number;
    lastIndexOf(element: T): number;
    lastIndexOf(element: T, fromIndex: number): number;
    findLastIndex(predicate: (element: T, index: number) => boolean): number;
    length(): number;
    length(predicate: (element: T, index: number) => boolean): number;
    first(): T | undefined;
    find(predicate: (element: T, index: number) => boolean): T | undefined;
    last(): T | undefined;
    findLast(predicate: (element: T, index: number) => boolean): T | undefined;
    average(): number | undefined;
    average(selector: (element: T, index: number) => number): number | undefined;
    min(): T | undefined;
    min(compareFn: (element1: T, element2: T) => number): T | undefined;
    max(): T | undefined;
    max(compareFn: (element1: T, element2: T) => number): T | undefined;
    sum(): number | undefined;
    sum(selector: (element: T, index: number) => number): number | undefined;
    reduce(callback: (accumulator: T, current: T, index: number) => T): T;
    reduce<S>(callback: (accumulator: S, current: T, index: number) => S, initialValue: S): S;
    reduceRight<S, TResult>(callback: (accumulator: TResult, current: T, index: number) => TResult): TResult;
    reduceRight<S>(callback: (accumulator: S, current: T, index: number) => S, initialValue: S): S;
    forEach(action: (element: T, index: number) => void): void;
}
